package DPEMS;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class ProductInfo extends DPEMS {
	void productInfoEntry() {
		try {
			System.out.println("-----Product Info Entry-----");
			System.out.println("Enter Product ID");
			int pi = sc.nextInt();
			int productId[] = new int[1000];
			String qs = "select * from productInfo";
			PreparedStatement pst1 = con.prepareStatement(qs);
			ResultSet resultSet = pst1.executeQuery();
			while (resultSet.next()) {
				for (int i = 0; i < productId.length; i++) {
					productId[i] = resultSet.getInt("product_id");
					if (productId[i] == pi) {
						System.out.println("This product id already exist enter another product id");
						pi = sc.nextInt();
						i = 0;
					}
				}
			}
			System.out.println("Enter product name");
			String pn = sc.nextLine();
			while (pn.length() <= 0) {
				pn = sc.nextLine();
				resultSet = pst1.executeQuery();
				String productName[] = new String[1000];
				while (resultSet.next()) {
					for (int i = 0; i < productName.length; i++) {
						productName[i] = resultSet.getString("product_name");
						if (productName[i].equalsIgnoreCase(pn) || productName[i].equals(pn)) {
							System.out.println("This product name already exist enter another product name");
							pn = sc.nextLine();
							i = 0;
						}
					}
				}
				if (pn.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			System.out.println("Enter description ");
			String pd = "";
			while (pd.length() <= 0) {
				pd = sc.nextLine();
				if (pd.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			System.out.println("Enter category");
			String pc = "";
			while (pc.length() <= 0) {
				pc = sc.nextLine();
				if (pc.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			System.out.println("Enter quantity");
			float pq = -1;
			while (pq < 0) {
				pq = sc.nextInt();
				if (pq < 0) {
					System.out.println("Quantity cannot be negative. Enter a non-negative quantity:");
				}
			}
			System.out.println("Enter 1 liter price");
			double pp = -1.0;
			while (pp < 0.0) {
				pp = sc.nextDouble();
				if (pp < 0.0) {
					System.out.println("Price cannot be negative. Enter a non-negative price:");
				}
			}
			String q = "insert into productInfo(product_id,product_name,description,category,quantity,price)values(?,?,?,?,?,?)";
			PreparedStatement pst;
			pst = con.prepareStatement(q);
			pst.setInt(1, pi);
			pst.setString(2, pn);
			pst.setString(3, pd);
			pst.setString(4, pc);
			pst.setFloat(5, pq);
			pst.setDouble(6, pp);
			int res = pst.executeUpdate();
			System.out.println((res == 1) ? "Product Info Added Succesfully!!!" : "Not added Try Again!");
		} catch (SQLException e) {
			System.out.println("Something went wrong in SQL!!!");
		} catch (Exception e) {
			System.out.println("Something went wrong Try Again!!!");
		}
		sc.nextLine();
	}

	void productInfoupdate() {
		try {
			System.out.println("-----Product Info Update-----");
			String q1 = "select distinct (Product_name) from ProductInfo";
			PreparedStatement pst1 = con.prepareStatement(q1);
			ResultSet resultSet1 = pst1.executeQuery();
			System.out.println("Product Names: ");
			while (resultSet1.next()) {
				String Product_name = resultSet1.getString("Product_name");
				System.out.println(Product_name);
			}
			System.out.println("Enter Product_name");
			String pn = "";
			while (pn.length() <= 0) {
				pn = sc.nextLine();
				if (pn.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			System.out.println("Enter new price");
			double pp = -1.0;
			while (pp < 0.0) {
				pp = sc.nextDouble();
				if (pp < 0.0) {
					System.out.println("Price cannot be negative. Enter a non-negative price:");
				}
			}
			String q = "update productInfo set price=? where product_name=?";
			PreparedStatement pst = con.prepareStatement(q);
			pst.setDouble(1, pp);
			pst.setString(2, pn);
			int r = pst.executeUpdate();
			System.out.println((r > 0) ? "Updated Succesfully!!!" : "Not Updated!!");
		} catch (SQLException e) {
			System.out.println("Something went wrong in SQL Try Again!!!");
		} catch (Exception e) {
			System.out.println("Something went wrong Try Again!!!");
		}
		sc.nextLine();
	}

	void productInfoDeleted() {
		try {
			System.out.println("-----Product Info Deleted-----");
			String q1 = "select distinct (Product_name) from ProductInfo";
			PreparedStatement pst1 = con.prepareStatement(q1);
			ResultSet resultSet1 = pst1.executeQuery();
			System.out.println("Product Names: ");
			while (resultSet1.next()) {
				String Product_name = resultSet1.getString("Product_name");
				System.out.println(Product_name);
			}
			System.out.println("Enter Product_name");
			String pn = "";
			while (pn.length() <= 0) {
				pn = sc.nextLine();
				if (pn.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			String q = "delete from productInfo where  product_name=?";
			PreparedStatement pst = con.prepareStatement(q);
			pst.setString(1, pn);
			System.out.println("Press Y to confirm deletion...");
			char ch = sc.next().charAt(0);
			if (ch == 'y' || ch == 'Y') {
				int r = pst.executeUpdate();
				System.out.println((r > 0) ? "Deleted!!!" : "Not Deleted");
			} else {
				System.out.println("Process Terminated!!");
			}
		} catch (SQLException e) {
			System.out.println("Something went wrong in SQL Try Again!!!");
		} catch (Exception e) {
			System.out.println("Something went wrong Try Again!!!");
		}
		sc.nextLine();
	}

	void productInfoReport() {
		try {
			String q = "select * from productInfo";
			PreparedStatement pst1 = con.prepareStatement(q);
			ResultSet resultSet = pst1.executeQuery();
			System.out.println("-----Product Info Report-----");
			while (resultSet.next()) {
				int productId = resultSet.getInt("product_id");
				String productName = resultSet.getString("product_name");
				String description = resultSet.getString("description");
				String category = resultSet.getString("category");
				float quantity = resultSet.getFloat("quantity");
				double price = resultSet.getDouble("price");
				String dateAdded = resultSet.getString("date_added");
				System.out.println("Product ID: " + productId);
				System.out.println("Product Name: " + productName);
				System.out.println("Description: " + description);
				System.out.println("Category: " + category);
				System.out.println("Quantity: " + quantity);
				System.out.println("Price: $" + price);
				System.out.println("Date Added: " + dateAdded);
				System.out.println("-------------------------------------------");
			}
		} catch (SQLException e) {
			System.out.println("Something went wrong in SQL Try Again!!!");
		} catch (Exception e) {
			System.out.println("Something went wrong Try Again!!!");
		}
	}

}